/**
 * @file
 * Author: Synpase-studio.
 */

(function ($) {
  $(document).ready(function () {
    ymaps.ready(ymapsInit);

    function ymapsInit() {
      var pos = '<div class="ymap"><div id="synmap" style="min-height:500px"></div></div>';
      var mapData = drupalSettings.synmap;
      if (drupalSettings.synmapReplace) {
        // MapData REPLACE.
        mapData = drupalSettings.synmapReplace;
      }

      // Map.
      var mapSet = mapData.map;
      $(mapSet.attach).before(pos);
      var map = new ymaps.Map('synmap', {
        center: [mapSet.longitude, mapSet.latitude],
        zoom: mapSet.zoom,
        controls: ['zoomControl', 'fullscreenControl']
      });
      map.behaviors.disable('scrollZoom');

      // Points.
      var faIcon = 'map-marker',
          faLayout = ymaps.templateLayoutFactory.createClass(
            '<i class="fa fa-' + faIcon + '" aria-hidden="true"></i>'
          );
      $.each(mapData.data, function (index, point) {
        var Placemark = new ymaps.Placemark(
          [point.longitude, point.latitude],
          {balloonContent: point.name},
          {iconLayout: faLayout}
        );
        map.geoObjects.add(Placemark);
      });
      // Center Position.
      if (mapSet.centerAuto === true) {
        var bounds = map.geoObjects.getBounds();
        map.setBounds(bounds, {checkZoomRange:true}).then(function () {
          if (map.getZoom() > 16) {
            map.setZoom(16);
          }
        });
      }
      else {
        // Move center.
        var position = map.getGlobalPixelCenter();
        map.setGlobalPixelCenter([
          position[0] - mapSet.centerAutoX,
          position[1] - mapSet.centerAutoY
        ]);
      }
    }
  });
})(this.jQuery);
